<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../">
  <title data-ice="title">public/js/catalouge/Catalog_System_Base.js | archive-system-front-end</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
</head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/ArchiveSys/Web-Catalogue/archive-system-front-end.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js">js</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/moodral.js~moodral.html">moodral</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CONFIG">CONFIG</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge">js/catalouge</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System.js~Catalog_System.html">Catalog_System</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_System_Base.js~Catalog_System_Base.html">Catalog_System_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-archive-connection">js/catalouge/Archive_Connection</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Archive_Connection/Archive_Connection.js~Archive_Connection.html">Archive_Connection</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry">js/catalouge/Catalog_Entry</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry.js~Catalog_Entry.html">Catalog_Entry</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry/Catalog_Entry_Base.js~Catalog_Entry_Base.html">Catalog_Entry_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-catalog-entry-moodral">js/catalouge/Catalog_Entry_Moodral</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Catalog_Entry_Moodral/Catalog_Entry_Moodral.js~Catalog_Entry_Moodral.html">Catalog_Entry_Moodral</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-filter">js/catalouge/Filter</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter.js~Filter.html">Filter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Filter/Filter_Base.js~Filter_Base.html">Filter_Base</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-catalouge-page-headers">js/catalouge/Page_Headers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/catalouge/Page_Headers/Page_Headers.js~Page_Headers.html">Page_Headers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#js-toolkit">js/toolkit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/baseToolkit.js~toolkit.html">toolkit</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~baseStorageToolkitExtention.html">baseStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~permanentStorageToolkitExtention.html">permanentStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/combinedStorageToolkitExtention.js~sessionStorageToolkitExtention.html">sessionStorageToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/contentToolkitExtention.js~contentToolkitExtention.html">contentToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/endlessScrollToolkitExtention.js~endlessScrollToolkitExtention.html">endlessScrollToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/eventToolkitExtention.js~eventToolkitExtention.html">eventToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/formToolkitExtention.js~formToolkitExtention.html">formToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/httpConnectionsToolkitExtention.js~httpConnectionsToolkitExtention.html">httpConnectionsToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/styleToolkitExtention.js~styleToolkitExtention.html">styleToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/public/js/toolkit/urlToolkitExtention.js~urlToolkitExtention.html">urlToolkitExtention</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-aggregator">aggregator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-NOTHING">NOTHING</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">public/js/catalouge/Catalog_System_Base.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import { Catalog_Entry } from &apos;./Catalog_Entry/Catalog_Entry.js&apos;;
import { Archive_Connection } from &apos;./Archive_Connection/Archive_Connection.js&apos;;


/**
 * The actual catalog object, splits the data between the various sections of the code.
 */
export class Catalog_System_Base {
  /**
   * The constructor for the class.
   * @public
   * @param {String} API_Entrypoint - Where to send API requests.
   * @param {String} HTTP_Entrypoint - Where to get HTML data from.
   */
  constructor(API_Entrypoint, HTTP_Entrypoint){
    /**
     * Where to get HTML content from.
     * @private
     * @type {String}
     */
    this.HTTP_Entrypoint = HTTP_Entrypoint;
    /**
     * The filter object. Handles the search/filter menu.
     * @private
     * @type {Filter_Base}
     * @abstract
     * @todo replace the current object
     */
    this.filter = undefined;
    /**
     * All currently displayed entries.
     * @private
     * @type {Array&lt;Catalog_System_Base&gt;}
     */
    this.entries = [];
    /**
     * Every page with every entries that is on said page each page.
     * @private
     * @type {Array&lt;Array&lt;Catalog_System_Base&gt;&gt;}
     */
    this.pages = [];
    /**
     * The connection to the archive.
     * @private
     * @type {Archive_Connection}
     */
    this.connection = new Archive_Connection(API_Entrypoint, this);
  }

  /**
   * Changes the entrypoint, mostly used for switching to a dev API instance.
   *
   * @param {URL} HTTP_Entrypoint
   * @param {URL} API_Entrypoint
   */
  changeEndpoint(HTTP_Entrypoint, API_Entrypoint){
    if(HTTP_Entrypoint){
      this.HTTP_Entrypoint = HTTP_Entrypoint;
    }
    if(API_Entrypoint){
      this.connection.changeEndpoint(API_Entrypoint);
    }
  }

  /**
   * Clears the currently saved entries and the list of currently saved entries.
   * @public
   */
  clearEntries(){
    this.entries = [];
    this.pages = [];
    this.filter.setPage(1);
  }

  /**
   * Full reload with the new filter parameters.
   * Call this when changeing the search filters.
   * @public
   */
  reloadFilter(){
    this.clearEntries();
    let self = this;
    this.connection.loadEntryAndOptions();
  }

  /**
   * Starts the load of the next page for the catalog.
   * @public
   */
  nextPage(){
    // add loading spinner
    let self = this;
    this.connection.loadEntryAndOptions();
  }

  /**
   * Called when the catalog data is returned.
   * @private
   * @param {Object} catalogList - A page of catalog entries to display on page one.
   */
  __prossessAPage(catalogList){
    let self = this;
    let localPage = [];
    catalogList.forEach((data, index) =&gt; {self.__addEntry(data, localPage);});
    this.pages.push(localPage);
    return localPage;
  }

  /**
   * Adds a entry to the catalouge.
   * @private
   * @param {Object} entryData - The Individual entry&apos;s data
   * @param {number} page - the page that this item should be added to.
   */
  __addEntry(entryData, page){
    let thisEntry = new Catalog_Entry(entryData, this, this.HTTP_Entrypoint);
    this.entries.push(thisEntry);
    page.push(thisEntry);
  }
}
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
